import java.util.*;

/**
 * A tool to choose the unit to which we have to send an order.
 *
 * @author Pietro Terna
 * @author Michele Sonnessa: JAS porting 
 */
public class AssigningTool
{
	/** the list of the normal units existing in our environment*/
	public ArrayList unitList;

	/** the temporary address of an existing unit */
	public Unit aUnit;

	public AssigningTool (ArrayList ul)
	{
		// the list of the normal units
		unitList=ul;
	}

	public void assign(Order firstOrder)
	{
		// normal case
		boolean unitNotFound = true;
	
		ListIterator unitListIndex = unitList.listIterator();
		while (unitListIndex.hasNext() && unitNotFound)
		{
			aUnit=(Unit)unitListIndex.next();
			if (firstOrder.getNextStep() ==	aUnit.getProductionPhase())
			    unitNotFound=false;
		}
	
		if (unitNotFound)
		{
			System.out.println(
		     "Internal error attempting to send an order; receiving unit does not exists.");
			System.out.println(
				   "The error arises from order # "
				   +firstOrder.getOrderNumber()+
				   " recipe name "+
					   firstOrder.getRecipeName());
			System.exit(1);
		}
		else //unit found
			aUnit.setWaitingList(firstOrder);
		
	}

}
